#!/bin/sh

set -euC

att() {
    [ -n "${TMUX:-}" ] &&
        tmux switch-client -t '=session' ||
        tmux attach-session -t '=session'
}

if tmux has-session -t '=session' 2> /dev/null; then
    att
    exit 0
fi

tmux new-session -d -s session

tmux send-keys -t session 'htop' Enter

tmux splitw bash
tmux resize-pane -U 25
tmux send-keys -t session 'git pull; git checkout $branch; git pull' Enter
tmux send-keys -t session 'ls -t run-results/*/*.pt | head -n 1' Enter
tmux send-keys -t session 'ls -t run-results/*.csv | head -n 1' Enter
tmux send-keys -t session 'cat `ls -t run-results/*.csv | head -n 1`' Enter
tmux send-keys -t session 'rm run-results/eval-acc.jsonl; git pull; cabal run synthesizer -- --taskPath="../synth-gen/run-results/datasets-3.yml" --bestOf=100 --seed=$seed'

att
